/*

    this source file is a part of 
    lp_parse - a preprocessor for MILP models
    Copyright (C) 1996  Ari Jolma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    for more information please contact 
    Ari Jolma
    Helsinki University of Technology
    Laboratory of Water Resources Engineering
    Building W
    02150 Espoo, Finland
    E-mail: Ari.Jolma@hut.fi

 */

#define HASH_H

#define ITEM_DATA void *next; char *name

struct item {
  ITEM_DATA;
};

#define ITEM struct item

int init_item(ITEM *item, char *name);

ITEM *new_item(char *name);

void delete_item(ITEM *item);

void dispose_item(ITEM *item);

#define HASH ITEM *

HASH *new_hash();

void delete_hash(HASH *hash);

void dispose_hash(HASH *hash);

void ahash(HASH *hash, ITEM *item);

ITEM *ghash(HASH *hash, char *name);

int nitems(HASH *hash);

ITEM **items(HASH *hash, int nitems);
